# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule SubspaceProductAPI.Api.ProjectService do
  @moduledoc """
  API calls for all endpoints tagged `ProjectService`.
  """

  alias SubspaceProductAPI.Connection
  import SubspaceProductAPI.RequestBuilder


  @doc """

  ## Parameters

  - connection (SubspaceProductAPI.Connection): Connection to server
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, SubspaceProductAPI.Model.V1Project.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec project_service_create(Tesla.Env.client, keyword()) :: {:ok, SubspaceProductAPI.Model.V1Project.t} | {:ok, Map.t} | {:error, Tesla.Env.t}
  def project_service_create(connection, _opts \\ []) do
    %{}
    |> method(:post)
    |> url("/v1/project")
    |> ensure_body()
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %SubspaceProductAPI.Model.V1Project{}},
      { :default, false}
    ])
  end

  @doc """

  ## Parameters

  - connection (SubspaceProductAPI.Connection): Connection to server
  - id (String.t): 
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, SubspaceProductAPI.Model.V1Project.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec project_service_get(Tesla.Env.client, String.t, keyword()) :: {:ok, SubspaceProductAPI.Model.V1Project.t} | {:ok, Map.t} | {:error, Tesla.Env.t}
  def project_service_get(connection, id, _opts \\ []) do
    %{}
    |> method(:get)
    |> url("/v1/project/#{id}")
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %SubspaceProductAPI.Model.V1Project{}},
      { :default, false}
    ])
  end

  @doc """

  ## Parameters

  - connection (SubspaceProductAPI.Connection): Connection to server
  - opts (KeywordList): [optional] Optional parameters
    - :before (String.t): 
    - :limit (integer()): 
  ## Returns

  {:ok, SubspaceProductAPI.Model.V1ListProjectsResponse.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec project_service_list(Tesla.Env.client, keyword()) :: {:ok, Map.t} | {:ok, SubspaceProductAPI.Model.V1ListProjectsResponse.t} | {:error, Tesla.Env.t}
  def project_service_list(connection, opts \\ []) do
    optional_params = %{
      :"before" => :query,
      :"limit" => :query
    }
    %{}
    |> method(:get)
    |> url("/v1/project")
    |> add_optional_params(optional_params, opts)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %SubspaceProductAPI.Model.V1ListProjectsResponse{}},
      { :default, false}
    ])
  end

  @doc """

  ## Parameters

  - connection (SubspaceProductAPI.Connection): Connection to server
  - id (String.t): id is the project identity
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, SubspaceProductAPI.Model.V1Project.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec project_service_update(Tesla.Env.client, String.t, keyword()) :: {:ok, SubspaceProductAPI.Model.V1Project.t} | {:ok, Map.t} | {:error, Tesla.Env.t}
  def project_service_update(connection, id, _opts \\ []) do
    %{}
    |> method(:put)
    |> url("/v1/project/#{id}")
    |> ensure_body()
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %SubspaceProductAPI.Model.V1Project{}},
      { :default, false}
    ])
  end
end
